import { Type } from '@nestjs/common';
import { ModuleRef } from '@nestjs/core';
import 'reflect-metadata';
import { CommandBus as BaseCommandBus, ICommand, ICommandBus, ICommandHandler } from '@nestjs/cqrs';
import { ISerializableCommand } from "./serializable";
import { NestjsMicroservicesCqrs } from "./services";
export declare type CommandHandlerType = Type<ICommandHandler<ICommand>>;
export declare class CommandBus<CommandBase extends ISerializableCommand = ISerializableCommand> extends BaseCommandBus<CommandBase> implements ICommandBus<CommandBase> {
    private readonly _moduleRef;
    private readonly _nmc;
    constructor(_moduleRef: ModuleRef, _nmc: NestjsMicroservicesCqrs);
    private isExternal;
    private emit;
    execute<T extends CommandBase>(command: T): Promise<any>;
    executeLocally<T extends CommandBase>(command: T): Promise<any>;
    protected registerHandler(handler: CommandHandlerType): void;
    private subscribeGlobally;
    private _reflectGlobalCommand;
    private _reflectCommandName;
}
